/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "draw.h"
extern GtkWidget *darea_main;
extern GtkWidget *darea_wait;
extern GtkWidget *clist_gover;
extern GtkWidget *label_cerror_dialog;


GtkWidget*
create_win_main (void)
{
  GtkWidget *win_main;
  GtkWidget *vbox_main;
  GtkWidget *hbox_main_buttons;
  GtkWidget *btn_setting;
  GtkWidget *vbox_btn_setting;
  GtkWidget *pix_setting;
  GtkWidget *label_setting;
  GtkWidget *btn_start;
  GtkWidget *vbox_btn_start;
  GtkWidget *pix_start;
  GtkWidget *label_start;
  GtkWidget *btn_quit;
  GtkWidget *vbox_btn_quit;
  GtkWidget *pix_quit;
  GtkWidget *label_quit;
  GtkWidget *btn_info;
  GtkWidget *vbox_btn_info;
  GtkWidget *pix_info;
  GtkWidget *label_info;
  GtkWidget *darea;

  win_main = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (win_main), "win_main", win_main);
  gtk_window_set_title (GTK_WINDOW (win_main), _("netype"));
  gtk_window_set_position (GTK_WINDOW (win_main), GTK_WIN_POS_CENTER);
  gtk_window_set_policy (GTK_WINDOW (win_main), FALSE, FALSE, FALSE);

  vbox_main = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_main);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "vbox_main", vbox_main,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_main);
  gtk_container_add (GTK_CONTAINER (win_main), vbox_main);

  hbox_main_buttons = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox_main_buttons);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "hbox_main_buttons", hbox_main_buttons,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_main_buttons);
  gtk_box_pack_start (GTK_BOX (vbox_main), hbox_main_buttons, TRUE, TRUE, 0);

  btn_setting = gtk_button_new ();
  gtk_widget_ref (btn_setting);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "btn_setting", btn_setting,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_setting);
  gtk_box_pack_start (GTK_BOX (hbox_main_buttons), btn_setting, FALSE, TRUE, 0);
  GTK_WIDGET_UNSET_FLAGS (btn_setting, GTK_CAN_FOCUS);

  vbox_btn_setting = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_btn_setting);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "vbox_btn_setting", vbox_btn_setting,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_btn_setting);
  gtk_container_add (GTK_CONTAINER (btn_setting), vbox_btn_setting);

  pix_setting = create_pixmap (win_main, "setting.xpm");
  gtk_widget_ref (pix_setting);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "pix_setting", pix_setting,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_setting);
  gtk_box_pack_start (GTK_BOX (vbox_btn_setting), pix_setting, TRUE, TRUE, 0);

  label_setting = gtk_label_new (_("Setting"));
  gtk_widget_ref (label_setting);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "label_setting", label_setting,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_setting);
  gtk_box_pack_start (GTK_BOX (vbox_btn_setting), label_setting, FALSE, FALSE, 0);

  btn_start = gtk_button_new ();
  gtk_widget_ref (btn_start);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "btn_start", btn_start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_start);
  gtk_box_pack_start (GTK_BOX (hbox_main_buttons), btn_start, FALSE, TRUE, 0);
  GTK_WIDGET_UNSET_FLAGS (btn_start, GTK_CAN_FOCUS);

  vbox_btn_start = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_btn_start);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "vbox_btn_start", vbox_btn_start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_btn_start);
  gtk_container_add (GTK_CONTAINER (btn_start), vbox_btn_start);

  pix_start = create_pixmap (win_main, "start.xpm");
  gtk_widget_ref (pix_start);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "pix_start", pix_start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_start);
  gtk_box_pack_start (GTK_BOX (vbox_btn_start), pix_start, TRUE, TRUE, 0);

  label_start = gtk_label_new (_("Start"));
  gtk_widget_ref (label_start);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "label_start", label_start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_start);
  gtk_box_pack_start (GTK_BOX (vbox_btn_start), label_start, FALSE, FALSE, 0);

  btn_quit = gtk_button_new ();
  gtk_widget_ref (btn_quit);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "btn_quit", btn_quit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_quit);
  gtk_box_pack_start (GTK_BOX (hbox_main_buttons), btn_quit, FALSE, TRUE, 0);
  GTK_WIDGET_UNSET_FLAGS (btn_quit, GTK_CAN_FOCUS);

  vbox_btn_quit = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_btn_quit);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "vbox_btn_quit", vbox_btn_quit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_btn_quit);
  gtk_container_add (GTK_CONTAINER (btn_quit), vbox_btn_quit);

  pix_quit = create_pixmap (win_main, "quit.xpm");
  gtk_widget_ref (pix_quit);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "pix_quit", pix_quit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_quit);
  gtk_box_pack_start (GTK_BOX (vbox_btn_quit), pix_quit, TRUE, TRUE, 0);

  label_quit = gtk_label_new (_("Quit"));
  gtk_widget_ref (label_quit);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "label_quit", label_quit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_quit);
  gtk_box_pack_start (GTK_BOX (vbox_btn_quit), label_quit, FALSE, FALSE, 0);

  btn_info = gtk_button_new ();
  gtk_widget_ref (btn_info);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "btn_info", btn_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_info);
  gtk_box_pack_start (GTK_BOX (hbox_main_buttons), btn_info, FALSE, TRUE, 0);
  GTK_WIDGET_UNSET_FLAGS (btn_info, GTK_CAN_FOCUS);

  vbox_btn_info = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_btn_info);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "vbox_btn_info", vbox_btn_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_btn_info);
  gtk_container_add (GTK_CONTAINER (btn_info), vbox_btn_info);

  pix_info = create_pixmap (win_main, "info.xpm");
  gtk_widget_ref (pix_info);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "pix_info", pix_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_info);
  gtk_box_pack_start (GTK_BOX (vbox_btn_info), pix_info, TRUE, TRUE, 0);

  label_info = gtk_label_new (_("Info"));
  gtk_widget_ref (label_info);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "label_info", label_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_info);
  gtk_box_pack_start (GTK_BOX (vbox_btn_info), label_info, FALSE, FALSE, 0);

  darea = gtk_drawing_area_new ();
  gtk_widget_ref (darea);
  gtk_object_set_data_full (GTK_OBJECT (win_main), "darea", darea,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (darea);
  gtk_box_pack_start (GTK_BOX (vbox_main), darea, TRUE, TRUE, 0);
  gtk_widget_set_usize (darea, 640, 520);

  gtk_signal_connect (GTK_OBJECT (win_main), "key_press_event",
                      GTK_SIGNAL_FUNC (on_win_main_key_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (win_main), "delete_event",
                      GTK_SIGNAL_FUNC (delete_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (win_main), "destroy_event",
                      GTK_SIGNAL_FUNC (destroy_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_setting), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_setting_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_start), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_start_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_quit), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_quit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_info), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_info_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (darea), "configure_event",
                      GTK_SIGNAL_FUNC (on_darea_configure_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (darea), "expose_event",
                      GTK_SIGNAL_FUNC (on_darea_expose_event),
                      NULL);
  
  gtk_timeout_add(100, draw_questions, (gpointer)darea);

  return win_main;
}

GtkWidget*
create_win_setting (void)
{
  GtkWidget *win_setting;
  GtkWidget *vbox;
  GtkWidget *pix_setting;
  GtkWidget *tbl_entry;
  GtkWidget *label_uname;
  GtkWidget *label_passwd;
  GtkWidget *label_hname;
  GtkWidget *label_port;
  GtkWidget *entry_uname;
  GtkWidget *entry_passwd;
  GtkWidget *combo_hname;
  GList *combo_hname_items = NULL;
  GtkWidget *entry_hname;
  GtkWidget *entry_port;
  GtkWidget *hbox_setting_button;
  GtkWidget *btn_setting_ok;
  GtkWidget *btn_setting_cancel;

  static GtkWidget *status_widgets[4];


  win_setting = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (win_setting), "win_setting", win_setting);
  gtk_window_set_title (GTK_WINDOW (win_setting), _("SETTING"));
  gtk_window_set_position (GTK_WINDOW (win_setting), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (win_setting), TRUE);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "vbox", vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (win_setting), vbox);

  pix_setting = create_pixmap (win_setting, "setting.xpm");
  gtk_widget_ref (pix_setting);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "pix_setting", pix_setting,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_setting);
  gtk_box_pack_start (GTK_BOX (vbox), pix_setting, TRUE, TRUE, 0);

  tbl_entry = gtk_table_new (4, 2, TRUE);
  gtk_widget_ref (tbl_entry);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "tbl_entry", tbl_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tbl_entry);
  gtk_box_pack_start (GTK_BOX (vbox), tbl_entry, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (tbl_entry), 20);

  label_uname = gtk_label_new (_("USER NAME"));
  gtk_widget_ref (label_uname);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "label_uname", label_uname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_uname);
  gtk_table_attach (GTK_TABLE (tbl_entry), label_uname, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label_passwd = gtk_label_new (_("PASSWORD"));
  gtk_widget_ref (label_passwd);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "label_passwd", label_passwd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_passwd);
  gtk_table_attach (GTK_TABLE (tbl_entry), label_passwd, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label_hname = gtk_label_new (_("HOST NAME"));
  gtk_widget_ref (label_hname);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "label_hname", label_hname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_hname);
  gtk_table_attach (GTK_TABLE (tbl_entry), label_hname, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  label_port = gtk_label_new (_("PORT"));
  gtk_widget_ref (label_port);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "label_port", label_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_port);
  gtk_table_attach (GTK_TABLE (tbl_entry), label_port, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);

  entry_uname = gtk_entry_new ();
  gtk_widget_ref (entry_uname);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "entry_uname", entry_uname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_uname);
  gtk_table_attach (GTK_TABLE (tbl_entry), entry_uname, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_uname), _("fun."));

  entry_passwd = gtk_entry_new ();
  gtk_widget_ref (entry_passwd);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "entry_passwd", entry_passwd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_passwd);
  gtk_table_attach (GTK_TABLE (tbl_entry), entry_passwd, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_visibility (GTK_ENTRY (entry_passwd), FALSE);

  combo_hname = gtk_combo_new ();
  gtk_widget_ref (combo_hname);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "combo_hname", combo_hname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (combo_hname);
  gtk_table_attach (GTK_TABLE (tbl_entry), combo_hname, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  combo_hname_items = g_list_append (combo_hname_items, _(""));
  combo_hname_items = g_list_append (combo_hname_items, _(""));
  gtk_combo_set_popdown_strings (GTK_COMBO (combo_hname), combo_hname_items);
  g_list_free (combo_hname_items);

  entry_hname = GTK_COMBO (combo_hname)->entry;
  gtk_widget_ref (entry_hname);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "entry_hname", entry_hname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_hname);
  gtk_entry_set_text (GTK_ENTRY (entry_hname), _(""));

  entry_port = gtk_entry_new ();
  gtk_widget_ref (entry_port);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "entry_port", entry_port,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_port);
  gtk_table_attach (GTK_TABLE (tbl_entry), entry_port, 1, 2, 3, 4,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_text (GTK_ENTRY (entry_port), _("2345"));

  hbox_setting_button = gtk_hbox_new (TRUE, 0);
  gtk_widget_ref (hbox_setting_button);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "hbox_setting_button", hbox_setting_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox_setting_button);
  gtk_box_pack_start (GTK_BOX (vbox), hbox_setting_button, TRUE, TRUE, 0);

  btn_setting_ok = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (btn_setting_ok);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "btn_setting_ok", btn_setting_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_setting_ok);
  gtk_box_pack_start (GTK_BOX (hbox_setting_button), btn_setting_ok, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (btn_setting_ok), 10);

  btn_setting_cancel = gtk_button_new_with_label (_("Cancel"));
  gtk_widget_ref (btn_setting_cancel);
  gtk_object_set_data_full (GTK_OBJECT (win_setting), "btn_setting_cancel", btn_setting_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_setting_cancel);
  gtk_box_pack_start (GTK_BOX (hbox_setting_button), btn_setting_cancel, FALSE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (btn_setting_cancel), 10);

  status_widgets[0] = entry_uname;
  status_widgets[1] = entry_passwd;
  status_widgets[2] = entry_hname;
  status_widgets[3] = entry_port;

  gtk_signal_connect (GTK_OBJECT (btn_setting_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_setting_ok_clicked),
                      status_widgets);
  gtk_signal_connect (GTK_OBJECT (btn_setting_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_setting_cancel_clicked),
                      NULL);

  return win_setting;
}

GtkWidget*
create_win_start_error_dialog (void)
{
  GtkWidget *win_start_error_dialog;
  GtkWidget *vbox;
  GtkWidget *pix_start_dialog;
  GtkWidget *label;
  GtkWidget *cwin;
  GtkWidget *clist1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *btn_start_error_dialog_ok;

  win_start_error_dialog = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (win_start_error_dialog), "win_start_error_dialog", win_start_error_dialog);
  gtk_window_set_title (GTK_WINDOW (win_start_error_dialog), _("ERROR"));
  gtk_window_set_position (GTK_WINDOW (win_start_error_dialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (win_start_error_dialog), TRUE);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox);
  gtk_object_set_data_full (GTK_OBJECT (win_start_error_dialog), "vbox", vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (win_start_error_dialog), vbox);

  pix_start_dialog = create_pixmap (win_start_error_dialog, "error.xpm");
  gtk_widget_ref (pix_start_dialog);
  gtk_object_set_data_full (GTK_OBJECT (win_start_error_dialog), "pix_start_dialog", pix_start_dialog,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_start_dialog);
  gtk_box_pack_start (GTK_BOX (vbox), pix_start_dialog, TRUE, TRUE, 0);

  label = gtk_label_new (_("SETTING IS VIOLATION"));
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (win_start_error_dialog), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);

  cwin = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (cwin);
  gtk_object_set_data_full (GTK_OBJECT (win_start_error_dialog), "cwin", cwin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cwin);
  gtk_box_pack_start (GTK_BOX (vbox), cwin, TRUE, TRUE, 0);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (cwin), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  clist1 = gtk_clist_new (2);
  gtk_widget_ref (clist1);
  gtk_object_set_data_full (GTK_OBJECT (win_start_error_dialog), "clist1", clist1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (cwin), clist1);
  gtk_widget_set_sensitive (clist1, FALSE);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 0, 94);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 1, 111);
  gtk_clist_column_titles_show (GTK_CLIST (clist1));

  label2 = gtk_label_new (_("VARIABLE"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (win_start_error_dialog), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 0, label2);

  label3 = gtk_label_new (_("VALUE"));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (win_start_error_dialog), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 1, label3);

  btn_start_error_dialog_ok = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (btn_start_error_dialog_ok);
  gtk_object_set_data_full (GTK_OBJECT (win_start_error_dialog), "btn_start_error_dialog_ok", btn_start_error_dialog_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_start_error_dialog_ok);
  gtk_box_pack_start (GTK_BOX (vbox), btn_start_error_dialog_ok, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (btn_start_error_dialog_ok), 10);
  GTK_WIDGET_UNSET_FLAGS (btn_start_error_dialog_ok, GTK_CAN_FOCUS);

  gtk_signal_connect (GTK_OBJECT (btn_start_error_dialog_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_start_error_dialog_ok_clicked),
                      NULL);

  return win_start_error_dialog;
}

GtkWidget*
create_win_info (void)
{
  GtkWidget *win_info;
  GtkWidget *vbox_info;
  GtkWidget *pix_info;
  GtkWidget *swin_info;
  GtkWidget *txt_info;
  GtkWidget *btn_ok;

  win_info = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (win_info), "win_info", win_info);
  gtk_window_set_title (GTK_WINDOW (win_info), _("INFOMATION"));
  gtk_window_set_position (GTK_WINDOW (win_info), GTK_WIN_POS_CENTER);
  gtk_window_set_default_size (GTK_WINDOW (win_info), 300, 300);

  vbox_info = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox_info);
  gtk_object_set_data_full (GTK_OBJECT (win_info), "vbox_info", vbox_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox_info);
  gtk_container_add (GTK_CONTAINER (win_info), vbox_info);

  pix_info = create_pixmap (win_info, "info.xpm");
  gtk_widget_ref (pix_info);
  gtk_object_set_data_full (GTK_OBJECT (win_info), "pix_info", pix_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_info);
  gtk_box_pack_start (GTK_BOX (vbox_info), pix_info, TRUE, TRUE, 0);

  swin_info = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (swin_info);
  gtk_object_set_data_full (GTK_OBJECT (win_info), "swin_info", swin_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (swin_info);
  gtk_box_pack_start (GTK_BOX (vbox_info), swin_info, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (swin_info), 5);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (swin_info), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);

  txt_info = gtk_text_new (NULL, NULL);
  gtk_widget_ref (txt_info);
  gtk_object_set_data_full (GTK_OBJECT (win_info), "txt_info", txt_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (txt_info);
  gtk_container_add (GTK_CONTAINER (swin_info), txt_info);
  gtk_widget_realize (txt_info);
  gtk_text_insert (GTK_TEXT (txt_info), NULL, NULL, NULL,
                   _("Netype version 0.1"), 18);

  btn_ok = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (btn_ok);
  gtk_object_set_data_full (GTK_OBJECT (win_info), "btn_ok", btn_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_ok);
  gtk_box_pack_start (GTK_BOX (vbox_info), btn_ok, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (btn_ok), 10);

  gtk_signal_connect (GTK_OBJECT (btn_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_info_ok_clicked),
                      NULL);

  return win_info;
}

GtkWidget*
create_win_connection_error_dialog (void)
{
  GtkWidget *win_connection_error_dialog;
  GtkWidget *vbox;
  GtkWidget *pix_connection_error;
  GtkWidget *label_error;
  GtkWidget *label_error_info;
  GtkWidget *btn_ok;

  win_connection_error_dialog = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (win_connection_error_dialog), "win_connection_error_dialog", win_connection_error_dialog);
  gtk_window_set_title (GTK_WINDOW (win_connection_error_dialog), _("CONNECTION ERROR"));
  gtk_window_set_position (GTK_WINDOW (win_connection_error_dialog), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (win_connection_error_dialog), TRUE);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox);
  gtk_object_set_data_full (GTK_OBJECT (win_connection_error_dialog), "vbox", vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (win_connection_error_dialog), vbox);

  pix_connection_error = create_pixmap (win_connection_error_dialog, "error.xpm");
  gtk_widget_ref (pix_connection_error);
  gtk_object_set_data_full (GTK_OBJECT (win_connection_error_dialog), "pix_connection_error", pix_connection_error,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pix_connection_error);
  gtk_box_pack_start (GTK_BOX (vbox), pix_connection_error, TRUE, TRUE, 0);

  label_error = gtk_label_new (_("CONNECTION ERROR"));
  gtk_widget_ref (label_error);
  gtk_object_set_data_full (GTK_OBJECT (win_connection_error_dialog), "label_error", label_error,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_error);
  gtk_box_pack_start (GTK_BOX (vbox), label_error, FALSE, FALSE, 0);
  gtk_widget_set_usize (label_error, 180, 45);

  label_error_info = gtk_label_new (_("ERROR INFO"));
  gtk_widget_ref (label_error_info);
  gtk_object_set_data_full (GTK_OBJECT (win_connection_error_dialog), "label_error_info", label_error_info,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_error_info);
  gtk_box_pack_start (GTK_BOX (vbox), label_error_info, TRUE, TRUE, 0);

  btn_ok = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (btn_ok);
  gtk_object_set_data_full (GTK_OBJECT (win_connection_error_dialog), "btn_ok", btn_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_ok);
  gtk_box_pack_start (GTK_BOX (vbox), btn_ok, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (btn_ok), 10);

  gtk_signal_connect (GTK_OBJECT (btn_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_connection_error_dialog_ok_clicked),
                      NULL);

  label_cerror_dialog = label_error_info;

  return win_connection_error_dialog;
}

GtkWidget*
create_win_wait (void)
{
  GtkWidget *win_wait;
  GtkWidget *vbox1;
  GtkWidget *pixmap1;
  GtkWidget *label;
  GtkWidget *darea;

  win_wait = gtk_window_new (GTK_WINDOW_POPUP);
  gtk_object_set_data (GTK_OBJECT (win_wait), "win_wait", win_wait);
  gtk_container_set_border_width (GTK_CONTAINER (win_wait), 5);
  gtk_window_set_title (GTK_WINDOW (win_wait), _("WAIT"));
  gtk_window_set_position (GTK_WINDOW (win_wait), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (win_wait), TRUE);
  gtk_window_set_default_size (GTK_WINDOW (win_wait), 200, 200);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (win_wait), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (win_wait), vbox1);

  pixmap1 = create_pixmap (win_wait, "wait.xpm");
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (win_wait), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (vbox1), pixmap1, TRUE, TRUE, 0);

  label = gtk_label_new (_("WAIT!"));
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (win_wait), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox1), label, FALSE, FALSE, 0);

  darea = gtk_drawing_area_new ();
  gtk_widget_ref (darea);
  gtk_object_set_data_full (GTK_OBJECT (win_wait), "darea", darea,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (darea);
  gtk_box_pack_start (GTK_BOX (vbox1), darea, FALSE, FALSE, 0);
  gtk_widget_set_usize (darea, 90, 90);

  darea_wait = darea;

  return win_wait;
}

GtkWidget*
create_win_gover (void)
{
  GtkWidget *win_gover;
  GtkWidget *vbox;
  GtkWidget *darea_game_over;
  GtkWidget *swin;
  GtkWidget *clist;
  GtkWidget *label_ranking;
  GtkWidget *label_uname;
  GtkWidget *label_score;
  GtkWidget *label;
  GtkWidget *btn_game_over_ok;

  win_gover = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (win_gover), "win_gover", win_gover);
  gtk_window_set_title (GTK_WINDOW (win_gover), _("GAME OVER"));
  gtk_window_set_position (GTK_WINDOW (win_gover), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (win_gover), TRUE);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox);
  gtk_object_set_data_full (GTK_OBJECT (win_gover), "vbox", vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (win_gover), vbox);

  darea_game_over = gtk_drawing_area_new ();
  gtk_widget_ref (darea_game_over);
  gtk_object_set_data_full (GTK_OBJECT (win_gover), "darea_game_over", darea_game_over,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (darea_game_over);
  gtk_box_pack_start (GTK_BOX (vbox), darea_game_over, TRUE, TRUE, 0);
  gtk_widget_set_usize (darea_game_over, 320, 240);

  swin = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (swin);
  gtk_object_set_data_full (GTK_OBJECT (win_gover), "swin", swin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (swin);
  gtk_box_pack_start (GTK_BOX (vbox), swin, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (swin), 10);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (swin), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clist = gtk_clist_new (3);
  gtk_widget_ref (clist);
  gtk_object_set_data_full (GTK_OBJECT (win_gover), "clist", clist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (clist);
  gtk_container_add (GTK_CONTAINER (swin), clist);
  gtk_widget_set_usize (clist, -2, 150);
  gtk_container_set_border_width (GTK_CONTAINER (clist), 2);
  GTK_WIDGET_UNSET_FLAGS (clist, GTK_CAN_FOCUS);
  gtk_clist_set_column_width (GTK_CLIST (clist), 0, 65);
  gtk_clist_set_column_width (GTK_CLIST (clist), 1, 84);
  gtk_clist_set_column_width (GTK_CLIST (clist), 2, 80);
  gtk_clist_column_titles_show (GTK_CLIST (clist));

  label_ranking = gtk_label_new (_("RANKING"));
  gtk_widget_ref (label_ranking);
  gtk_object_set_data_full (GTK_OBJECT (win_gover), "label_ranking", label_ranking,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_ranking);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 0, label_ranking);

  label_uname = gtk_label_new (_("USER NAME"));
  gtk_widget_ref (label_uname);
  gtk_object_set_data_full (GTK_OBJECT (win_gover), "label_uname", label_uname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_uname);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 1, label_uname);

  label_score = gtk_label_new (_("SCORE"));
  gtk_widget_ref (label_score);
  gtk_object_set_data_full (GTK_OBJECT (win_gover), "label_score", label_score,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_score);
  gtk_clist_set_column_widget (GTK_CLIST (clist), 2, label_score);

  label = gtk_label_new (_("GAME OVER"));
  gtk_widget_ref (label);
  gtk_object_set_data_full (GTK_OBJECT (win_gover), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, FALSE, 0);

  btn_game_over_ok = gtk_button_new_with_label (_("OK"));
  gtk_widget_ref (btn_game_over_ok);
  gtk_object_set_data_full (GTK_OBJECT (win_gover), "btn_game_over_ok", btn_game_over_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btn_game_over_ok);
  gtk_box_pack_start (GTK_BOX (vbox), btn_game_over_ok, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (btn_game_over_ok), 10);
  GTK_WIDGET_UNSET_FLAGS (btn_game_over_ok, GTK_CAN_FOCUS);

  gtk_signal_connect (GTK_OBJECT (darea_game_over), "configure_event",
                      GTK_SIGNAL_FUNC (on_darea_game_over_configure_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (darea_game_over), "expose_event",
                      GTK_SIGNAL_FUNC (on_darea_game_over_expose_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (btn_game_over_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_btn_game_over_ok_clicked),
                      NULL);

  clist_gover = clist;

  return win_gover;
}

