/*
  netype (Sample NTS Client) main.c

  Copyright (C) 2000 Raiko FUNAKAMI

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <gdk_imlib.h>
#include <stdlib.h>

#include "interface.h"
#include "support.h"

#include "gekic.h"

#include "ccat000_xpm.h"
#include "ccat001_xpm.h"
#include "ccat002_xpm.h"
#include "ccat003_xpm.h"

#include "scat000_xpm.h"
#include "scat001_xpm.h"
#include "scat002_xpm.h"
#include "scat003_xpm.h"


/* 
   carraycat Υǡ 
*/
type_sprite sprites_carrycat[] = {
  {carrycat00, NULL, NULL},
  {carrycat01, NULL, NULL},
  {carrycat02, NULL, NULL},
  {carrycat03, NULL, NULL},
  {NULL, NULL, NULL},
};
type_actor act_tmp_carrycat;      
/* 
   stealcat Υǡ 
*/
type_sprite sprites_stealcat[] = {
  {stealcat000, NULL, NULL},
  {stealcat001, NULL, NULL},
  {stealcat002, NULL, NULL},
  {stealcat003, NULL, NULL},
  {NULL, NULL, NULL},
};
type_actor act_tmp_stealcat;      


/*
  Pixmaps
*/
GdkPixmap *pix_darea = NULL;       /* darea Хåե */
GdkPixmap *pix_wall = NULL;
GdkPixmap *pix_board[3] = {NULL, NULL, NULL};
GdkBitmap *bit_board[3] = {NULL, NULL, NULL};

GdkPixmap *pix_you_win;
GdkPixmap *pix_you_lose;
GdkPixmap *pix_you_tohoho;
GdkPixmap *pix_gover;
/*
  Imlib Images
*/
GdkImlibImage *im_wall = NULL;
GdkImlibImage *im_board[3] = {NULL, NULL, NULL};

GdkImlibImage *im_you_win;
GdkImlibImage *im_you_lose;
GdkImlibImage *im_you_tohoho;


/*
  Windows
*/
GtkWidget *win_main;
GtkWidget *win_setting;
GtkWidget *win_start_error_dialog;
GtkWidget *win_info;
GtkWidget *win_connection_error_dialog;
GtkWidget *win_wait;
GtkWidget *win_gover;


/*
  Drawing Area 
*/
GtkWidget *darea_main;
GtkWidget *darea_wait;


/*
  Ranking List
*/
GtkWidget *clist_gover;


/*
  Error Dialog Label
*/
GtkWidget *label_cerror_dialog;

/* 
   Fonts 
*/
GdkFont *font_question = NULL;     


/* 
   Status 
*/
type_status *client_status = NULL; 






static GdkImlibImage *loag_image(char *file)
{
  static char filepath[1024];
  GdkImlibImage *im = NULL;

  sprintf(filepath,"%s/pixmaps/%s", PACKAGE_DATA_DIR, file);
  if((im = gdk_imlib_load_image(filepath)) == NULL){
    sprintf(filepath,"%s/pixmaps/%s", PACKAGE_SOURCE_DIR, file);
    if((im = gdk_imlib_load_image(filepath)) == NULL)
      g_error("Cannot read pixmap file : %s", file);
  }

  return im;
}
			

void load_etc_pixmaps(void){
  im_wall = loag_image("wall2.xpm");
  im_board[0] = loag_image("k0.xpm");
  im_board[1] = loag_image("k1.xpm");
  im_board[2] = loag_image("k2.xpm");

  gdk_imlib_render(im_board[0], im_board[0]->rgb_width, im_board[0]->rgb_height);
  pix_board[0] = gdk_imlib_move_image(im_board[0]);
  bit_board[0] = gdk_imlib_move_mask(im_board[0]);

  gdk_imlib_render(im_board[1], im_board[1]->rgb_width, im_board[1]->rgb_height);
  pix_board[1] = gdk_imlib_move_image(im_board[1]);
  bit_board[1] = gdk_imlib_move_mask(im_board[1]);

  gdk_imlib_render(im_board[2], im_board[2]->rgb_width, im_board[2]->rgb_height);
  pix_board[2] = gdk_imlib_move_image(im_board[2]);
  bit_board[2] = gdk_imlib_move_mask(im_board[2]);


  /*
    Game Over Pixmaps 
  */
  im_you_win = loag_image("wincat.xpm");
  im_you_lose = loag_image("losecat.xpm");
  im_you_tohoho = loag_image("tohohocat.xpm");

  gdk_imlib_render(im_you_win, im_you_win->rgb_width, im_you_win->rgb_height);
  pix_you_win = gdk_imlib_move_image(im_you_win);

  gdk_imlib_render(im_you_lose, im_you_lose->rgb_width, im_you_lose->rgb_height);
  pix_you_lose = gdk_imlib_move_image(im_you_lose);

  gdk_imlib_render(im_you_tohoho, im_you_tohoho->rgb_width, im_you_tohoho->rgb_height);
  pix_you_tohoho = gdk_imlib_move_image(im_you_tohoho);
}


int
main (int argc, char *argv[])
{

#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  gdk_imlib_init();


  /*
    Allocate Status Infomation Area
  */
  client_status = type_status_new();


  /* 
     load etc pixmaps
  */
  load_etc_pixmaps();
  
  

  /* 
     create main_window and show
  */
  win_main = create_win_main ();
  gtk_widget_show (win_main);


  /*
    create etc window and hide
  */
  win_setting = create_win_setting();
  win_start_error_dialog = create_win_start_error_dialog();
  win_info = create_win_info();
  win_connection_error_dialog = create_win_connection_error_dialog();
  win_wait = create_win_wait();
  win_gover = create_win_gover();

  //˥᡼ǡɤߤ
  load_pixmaps(win_main, &act_tmp_carrycat, sprites_carrycat);
  motion_set(&act_tmp_carrycat, -1, &motion_neko_leave);

  load_pixmaps(win_main, &act_tmp_stealcat, sprites_stealcat);
  motion_set(&act_tmp_stealcat, -1, &motion_neko_steal);
  

  /*
    եȤ
   */
  draw_font_init();


  /*
    Main Loop
  */
  gtk_main();

  return 0;
}


static gint compare_score(gconstpointer p1, gconstpointer p2)
{
  type_rank *r1 = (type_rank *)p1;
  type_rank *r2 = (type_rank *)p2;

  return (r1->score < r2->score);
}

static void hash_to_slist(gpointer key, gpointer value, gpointer data)
{

  GSList **slist = (GSList **)(data);
  type_rank *p = type_rank_new( (char*)key, GPOINTER_TO_INT(value));

  *slist = g_slist_insert_sorted(*slist, p, compare_score);
}

static void 
hash_reset(gpointer key, gpointer value, gpointer data)
{
  GHashTable *hash = (GHashTable*)data;

  g_hash_table_remove(hash, key);
}

static void game_start(type_status *status)
{
  gtk_widget_hide(win_wait);

  /*
    Set Status Flags
  */
  status->start  = TRUE;
  status->qlist_drawn = FALSE;
}


void reset_status(type_status *status)
{
  /*
    Set Status Flags
   */
  status->accept = FALSE;
  status->start = FALSE;
  status->end = TRUE;

  /*
    Close NetWork 
  */
  net_close(status->net_info);

  gdk_input_remove(status->net_info->read_tag);
  //gdk_input_remove(status->net_info->write_tag);
  g_free(status->net_info);
  status->net_info = NULL;

  /*
    Remove Answer
  */
  g_string_assign(status->pressed_keys, "");

  /*
    Remove Questions
  */
  type_status_remove_all_questions(status);
}

static void end_game(type_status *status)
{
  gboolean win_flag = FALSE;
  int rank_num;
  int my_rank = INT_MAX;
  char rank[10];
  char *buf[4];
  char score[10];
  GSList *list = NULL;
  GSList *node = NULL;

  /*
    Reset Status
  */
  reset_status(status);

  /*
    Make Ranking List
   */
  gtk_clist_clear(GTK_CLIST(clist_gover));
  g_hash_table_foreach(status->score_tbl, hash_to_slist, &list);

  rank_num = 1;
  for(node = list; node; node = node->next){
    type_rank *p = (type_rank *)node->data;

    sprintf(rank,  "%3d", rank_num);
    sprintf(score, "%3d", p->score);
    buf[0] = rank;
    buf[1] = p->name->str;
    buf[2] = score;
    buf[3] = NULL;
    gtk_clist_append(GTK_CLIST(clist_gover), buf);

    /*
      you lose or you win
    */
    if(rank_num == 1 && strcmp(p->name->str, client_status->user_name->str) == 0)
      win_flag = TRUE;

    /*
      your ranking check
    */
    if( strcmp(p->name->str, client_status->user_name->str) == 0){
      my_rank = rank_num;
      gtk_clist_select_row(GTK_CLIST(clist_gover), my_rank - 1, 0);
    }


    type_rank_free(p);
    ++rank_num;
  }

  /*
    Show Game Over Window 
  */
  if(win_flag == TRUE)
    pix_gover = pix_you_win;
  else if (my_rank <  rank_num - 1)
    pix_gover = pix_you_lose;
  else
    pix_gover = pix_you_tohoho;

  gtk_widget_hide(win_gover);
  gtk_widget_show_all(win_gover);


  /*
    Score Table Reset
  */
  g_hash_table_foreach(status->score_tbl, hash_reset, status->score_tbl);

  fprintf(stderr, "END: end_game\n");
}



static void 
set_score(type_status *status, GString* name_str, GString* score_str)
{
  int score;

  score = GPOINTER_TO_INT(g_hash_table_lookup(status->score_tbl, name_str->str));

  if(score == 0){
    score += atoi(score_str->str);
    g_hash_table_insert(status->score_tbl,
			g_strdup(name_str->str), 
			GINT_TO_POINTER(score));
  }else{
    score += atoi(score_str->str);
    g_hash_table_insert(status->score_tbl,
			name_str->str, 
			GINT_TO_POINTER(score));
  }

}


static GString* get_token(GString *word)
{
  GString *substr;
  GString *str = g_string_new(word->str);
  char* p = NULL;
  char* end = NULL;

  p = str->str;
  end = strchr(str->str, ' ');

  if(p == NULL)
    return NULL;
  
  if(end){
    *end = '\0';
    g_string_assign(word, end + 1);
  }

  substr = g_string_new(p);
  g_string_free(str, TRUE);

  return substr;
}

void chk_command(GString *line, type_status *status)
{
  GString *key;
  GString *arg[2];

  key = get_token(line);
  arg[0] = get_token(line);
  arg[1] = get_token(line);


  if(key == NULL)
    return;

  /*
  g_print("receive: %s\n", key->str);
  if(arg[0])
    g_print("arg1 : %s\n", arg[0]->str);
  if(arg[1])
    g_print("arg2 : %s\n", arg[1]->str);
  */   
  if(strcmp(key->str, "ACCEPT") == 0){
    status->accept = TRUE; 
  }
  else if(strcmp(key->str, "REJECT") == 0){
    status->accept = FALSE;
  }
  else if(strcmp(key->str, "START") == 0){
    game_start(status);  
  }
  else if(strcmp(key->str, "WAIT") == 0){
    if(!arg[0])
      return;

    draw_wait_time(darea_wait, arg[0]);
  }
  else if(strcmp(key->str, "PROBLEM") == 0){
    if(!arg[0] || !arg[1])
      return;

    type_status_append_question(status, arg[0], arg[1]);
  }
  else if(strcmp(key->str, "DELETE") == 0){
    if(!arg[0] || !arg[1])
      return;
    
    draw_set_animation(status, arg[0], arg[1]); 
    type_status_remove_question(status, arg[1]); 
  }
  else if(strcmp(key->str, "GOAL") == 0){
    if(!arg[0] || !arg[1])
      return;

    set_score(status, arg[0], arg[1]);
  }
  else if(strcmp(key->str, "END") == 0){
    end_game(status); 
  }else{
    g_print("not support protocol : %s\n", key->str);
  }


  if(key)
    g_string_free(key, TRUE);

  if(arg[0])
    g_string_free(arg[0], TRUE);

  if(arg[1])
    g_string_free(arg[1], TRUE);
}

