/*
  netype (Sample NTS Client) net.h

  Copyright (C) 2000 Raiko FUNAKAMI

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef NET_H
#define NET_H

#include <gtk/gtk.h>


typedef struct{
  GString* send_msg;
  GString* receive_msg;
  int socket;

  gint read_tag;
  gint write_tag;
}type_net_info;

type_net_info *net_init(gchar* hostname, int port);
int net_close(type_net_info *net_info);
void type_net_info_free(type_net_info *net_info);

void net_write(type_net_info *net_info, char* string);
void net_writeln(type_net_info *net_info, char* string);
int net_read(type_net_info *net_info);


void read_from_server(gpointer data, int socket, GdkInputCondition condition);
void write_to_server(gpointer data, int socket, GdkInputCondition condition);
type_net_info *connect_to_server(gchar* server, gchar* user_name, gchar* passwd, int port);

#endif /* NET_H */
