/*
  netype (Sample NTS Client) status.h

  Copyright (C) 2000 Raiko FUNAKAMI

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef STATE_H
#define STATE_H

#include <gtk/gtk.h>
#include "net.h"

typedef struct{
  GString *name;
  int score;
} type_rank;

typedef struct{
  GString* user_name; 
  GString* passwd;
  GString* host_name;
  int port;
			
  gboolean accept;
  gboolean start;
  gboolean end;

  GString *pressed_keys;

  /*
    Questions
  */
  GSList *qlist;
  gboolean qlist_drawn;

  
  /*
    Network
  */
  type_net_info *net_info;

  /*
    Score
  */
  GHashTable *score_tbl;

}type_status;


#define DFLAG_NORMAL       0
#define DFLAG_MY_SCORE     1
#define DFLAG_NOT_MY_SCORE 2
typedef struct{
  GString *phonogram;
  GString *ideogram;
  gint x;      /* ˥᡼ˤäѲ븽߰ */
  gint y;

  /* 
     DFLAG_NORMAL : none
     DFLAG_MY_SCORE : ʬˤʤä
     DFLAG_NOT_MY_SCORE : ¾ͤˤʤä
  */
  gint dflag;
		 
}type_question;


type_rank* type_rank_new(char* name, int score);
void type_rank_free(type_rank*);

type_question* type_question_new(GString* phonogram, GString* ideogram);
type_question* type_question_dup(type_question* old_q);
void type_question_free(type_question* q);

type_status* type_status_new();
void type_status_free(type_status *p);

void     type_status_append_question(type_status *status, GString *phonogram, GString *ideogram);
gboolean type_status_remove_question(type_status *status, GString *phonogram);
void     type_status_remove_all_questions(type_status *status);


type_question* type_status_find_question(type_status *status, GString *phonogram);


#endif /* STATE_H */
